/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "VarParams.h"
#include "GenParams.h"

#define DUMMYSIZE	1000

//--------------------------------------------------------------------------
// Dummy objects are used to flush the cache.
//--------------------------------------------------------------------------

class Dummy : public PObject
{
public:
    char		text[DUMMYSIZE];

public:
    Dummy();
    ~Dummy();
};

Implement PClassObj<Dummy>;


////////////////////////////////////////////////////////////////////////////
//
// Dummy Constructor
//
////////////////////////////////////////////////////////////////////////////

    // allocate the text array.
Dummy::Dummy()
{
}

// destructor
Dummy::~Dummy()
{
}


// create cnt dummy objects in a collection
void createDummy(o_4b cnt)
{
    o_4b		i;
    o_4b		n;
    LinkVstr<Dummy>	dummies;

    // create cnt dummy objects 
    dummies.set_size(1000);
    for (i = 0, n = 0; i < cnt ;i++, n++) 
    {
        // create a dummy
	dummies[n] = new Persistent Dummy();

	if ((i%1000) == 0) 
	{
	    printf("created %d dummy objects\n",i);
	    ::dom->commit();
	    ::dom->zapcods(dummies);
	    n = 0;
	}
    }
    dummies.release();
}


// scan DummySet collection retrieving all the dummy objects
void Purge()
{
    o_4b		size;
    LinkVstr<Dummy>	dummies = PClassObject<Dummy>::Object().select(
					    NULL, FALSE, NULL_PREDICATE);

    size = dummies.size();
    if ( size == 0 ) {
	fprintf(stderr,"ERROR: Dummy set is empty\n");
	exit(1);
    }
    for (o_4b i=0; i < size; i++) {
	Dummy*		dummy = dummies[i];
	char		c;

	if (dummy == NULL) {
           printf("Yikes, dummy was null.\n");
	}
        c = dummy->text[0]; // extract the first character
    }
    dummies.release();
    printf("number of dummy objects examined = %d\n",i);
}
